
### Libraries making this project possible

* [OpenJDK - Reference Java Virtual Machine and Java Standard Library implementations](https://openjdk.org/)
* [Kotlin programming language](https://kotlinlang.org/)
* [LWJGL - Lightweight Java Game Library](https://www.lwjgl.org/)
* [Lua, embeddable scripting language](https://www.lua.org/)
* [mimalloc, a compact general purpose allocator with excellent performance](https://github.com/microsoft/mimalloc)
* [fastutil - extends the Java™ Collections Framework by providing type-specific maps, sets, lists and queues. ](https://github.com/vigna/fastutil)
* [box2d - 2D Physics Engine](https://github.com/erincatto/box2d)
* [Guava - Google core libraries for Java](https://github.com/google/guava)
* [Gson - A Java serialization/deserialization library to convert Java Objects into JSON and back](https://github.com/google/gson)
* [Log4j - Apache Log4j 2 is a versatile, feature-rich, efficient logging API and backend for Java](https://github.com/apache/logging-log4j2)

### Snippets of code making this project possible

* [Super Fast Ray Casting in Tiled Worlds using DDA by javidx9](https://www.youtube.com/watch?v=NbSee-XM7WA)
* [Efficient HSV convertor inside Fragment Shader by Sam Hocevar](https://stackoverflow.com/questions/15095909/from-rgb-to-hsv-in-opengl-glsl)

### Special Thanks

* JetBrains
  * for creating amazing programming language Kotlin
  * for providing IntelliJ IDEA Community Edition free of charge for making these projects possible to write
* Curtis Schweitzer, your ability to make atmospheric music can not be described by words
* Starbound Community, for being passionate and determinant in keeping game alive
